<template>
  <div class="product-page">
    <div class="product-image-wrapper">
      <img
        :src="product.thumbnailUrl"
        :alt="product.name"
        class="product-image"
      />
    </div>
    <div class="product-details">
      <h1 class="product-name">{{ product.name }}</h1>
      <span class="product-description" v-html="product.description"></span>
      <p class="product-price">{{ product.defaultDisplayedPriceFormatted }}</p>
      <button class="buy-button" @click="addToCard">
        {{
          getCartCount.includes(product.id) ? "удалить из корзины" : "в корзину"
        }}
      </button>
    </div>
  </div>
</template>

<script>
import { mapGetters, mapActions, mapMutations } from "vuex";
export default {
  name: "ProductView",
  computed: {
    ...mapGetters(["getProducts", "getCartCount"]),
    products() {
      return this.getProducts;
    },
    cartCount() {
      return this.getCartCount;
    },
    product() {
      return this.products?.find((p) => p.id == this.$route.params.id) || {};
    },
  },

  async mounted() {
    await this.loadProducts();
  },

  methods: {
    ...mapMutations(["updateCartCount"]),
    ...mapActions(["fetchProducts"]),

    loadProducts() {
      this.fetchProducts();
    },
    addToCard() {
      this.updateCartCount(this.product.id);
    },
  },
};
</script>

<style scoped>
.product-page {
  display: flex;
  flex-direction: row;
  padding: 20px;
  max-width: 1200px;
  margin: 0 auto;
}

.product-image-wrapper {
  flex: 1;
  padding: 20px;
}

.product-image {
  width: 100%;
  height: auto;
  border-radius: 10px;
  box-shadow: 0 2px 5px rgba(0, 0, 0, 0.1);
}

.product-details {
  flex: 2;
  padding: 20px;
  display: flex;
  flex-direction: column;
  justify-content: center;
}

.product-name {
  font-size: 2em;
  margin-bottom: 20px;
}

.product-description {
  font-size: 1.2em;
  margin-bottom: 20px;
}

.product-price {
  font-size: 1.5em;
  color: #d9534f;
  margin-bottom: 20px;
  font-weight: bold;
}

.buy-button {
  border: none;
  background-color: black;
  color: #fff;
  padding: 15px 30px;
  border-radius: 5px;
  font-size: 1em;
  cursor: pointer;
  transition: background-color 0.3s ease;
  align-self: start;
}

.buy-button:hover {
  background-color: rgb(48, 47, 47);
}
</style>
